BulkyWeb/Areas/Admin/Controllers/CategoryController.cs
using Microsoft.AspNetCore.Mvc;
// using Microsoft.AspNetCore.Authorization;
//using Bulky.DataAccess.Data;
using Bulky.DataAccess.Repository.IRepository;
//using Bulky.DataAccess.Repository;
using Bulky.Models;
// using Bulky.Utils;

namespace BulkyWeb.Areas.Admin.Controllers
{
    [Area("Admin")]
    // [Authorize(Roles = SD.Role_Admin)]
    public class CategoryController : Controller
    {
        //private readonly ApplicationDbContext _db;
        // private readonly ICategoryRepository _CategoryRepo;
        private readonly IUnitOfWork _unitOfWork;

        public CategoryController(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }


        public IActionResult Index()
        {
            List<Category> O_CategoryList = _unitOfWork.Category.GetAll().ToList();
            return View(O_CategoryList.OrderBy(c => c.Id));
        }

        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(Category O_Cat)
        {
            if(O_Cat.Name == O_Cat.DisplayOrder.ToString()) {
                ModelState.AddModelError("name", "Display Order cannot exactly match the name");
            }
            if(O_Cat.Name == "test") {
                ModelState.AddModelError("", "test is an invalid name for a Category");
            }
            if(ModelState.IsValid)
            {
                _unitOfWork.Category.Add(O_Cat);
                _unitOfWork.Save();
                TempData["success"] = "Category created successfully";
                return RedirectToAction("Index");
            }
            return View(O_Cat);
        }

        public IActionResult Edit(int? id)
        {
            if (id is null && id == 0) {
                return NotFound();
            }
            Category? O_Cat = _unitOfWork.Category.Get(c => c.Id == id);

            if (O_Cat == null) {
                return NotFound();
            }
            return View(O_Cat);
        }

        [HttpPost]
        public IActionResult Edit(Category O_Cat)
        {
            if (O_Cat is null) {
                return NotFound();
            }

            if (ModelState.IsValid) {
                _unitOfWork.Category.Update(O_Cat);
                _unitOfWork.Save();
                TempData["success"] = "Category has been Updated";

                return RedirectToAction("Index");
            }
            return View(O_Cat);
        }

        public IActionResult Delete(int? id)
        {
            if (id is null && id == 0) {
                return NotFound();
            }
            Category? O_Cat = _unitOfWork.Category.Get(c => c.Id == id);

            if (O_Cat == null) {
                return NotFound();
            }
            return View(O_Cat);
        }

        [HttpPost, ActionName("Delete")]
        public IActionResult DeletePOST(int? id)
        {
            Category? O_Cat = _unitOfWork.Category.Get(c => c.Id == id);

            if (O_Cat is null) {
                return NotFound();
            }

            if (ModelState.IsValid) {
                _unitOfWork.Category.Remove(O_Cat);
                _unitOfWork.Save();
                TempData["success"] = "Category has been Removed";
            }

            return RedirectToAction("Index");
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View("Error!");
        }
    }
}

BulkyWeb/Areas/Admin/Views/Category/Create.cshtml
@model Bulky.Models.Category

<div class="card shadow border-0 mt-4">
    <div class="card-header bg-secondary bg-gradient ml-0 py-3">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">Create Category</h2>
            </div>
        </div>
    </div>
    <div class="card-body p-4">
        <form method="post" class="row">
            <div class="border p-3">
                <div class="row pb-2">
                    <!-- <hr/> -->
                </div>
                <!-- <div asp-validation-summary="All"></div> -->
                <!-- <div asp-validation-summary="ModelOnly"></div> -->
                <div class="form-floating py-2 col-12">
                    <input asp-for="Name" class="form-control border-0 shadow"></input>
                    <label asp-for="Name" class="ms-2"></label>
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="form-floating py-2 col-12">
                    <input asp-for="DisplayOrder" class="form-control border-0 shadow"></input>
                    <label asp-for="DisplayOrder" class="ms-2"></label>
                    <span asp-validation-for="DisplayOrder" class="text-danger"></span>
                </div>
                <div class="row pt-2">
                    <div class="col-md-6 col-md-3">
                        <button type="submit" class="btn btn-primary" style="width:120px">Create</button>
                        <a asp-controller="Category" asp-action="Index" class="btn btn-secondary" >Back to Categories</a>
                    </div>
                    <!-- <div class="col-3 col-md-3">
                         <a asp-controller="Category" asp-action="Index" class="btn btn-secondary" >Back to Categories</a>
                         </div> -->
                </div>

            </div>
        </form>
    </div>
</div>




@section scripts {
    @{
        <partial name="_ValidationScriptsPartial" />
    }
}

BulkyWeb/Areas/Admin/Views/Category/Delete.cshtml
@model Bulky.Models.Category

<div class="card shadow border-0 mt-4">
    <div class="card-header bg-secondary bg-gradient ml-0 py-3">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">Delete Category</h2>
            </div>
        </div>
    </div>
    <!-- Start Card Body -->
    <div class="card-body p-4">
        <form method="post" class="row">
            <div class="border p-3">
                <!-- <div asp-validation-summary="All"></div> -->
                <!-- <div asp-validation-summary="ModelOnly"></div> -->
                <div class="form-floating py-2 col-12">
                    <input asp-for="Name" class="form-control border-0 shadow" disabled></input>
                    <label asp-for="Name" class="ms-2"></label>
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="form-floating py-2 col-12">
                    <input asp-for="DisplayOrder" class="form-control border-0 shadow" disabled></input>
                    <label asp-for="DisplayOrder" class="ms-2"></label>
                    <span asp-validation-for="DisplayOrder" class="text-danger"></span>
                </div>
                <div class="row pt-2">
                    <div class="col-md-6 col-md-3">
                        <button type="submit" class="btn btn-primary" style="width:120px">Delete</button>
                        <a asp-controller="Category" asp-action="Index" class="btn btn-secondary" >Back to Categories</a>
                    </div>
                </div>
            </div>
        </form>
    </div>

</div>

BulkyWeb/Areas/Admin/Views/Category/Edit.cshtml
@model Bulky.Models.Category


<div class="card shadow border-0 mt-4">
    <div class="card-header bg-secondary bg-gradient ml-0 py-3">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">Edit Category</h2>
            </div>
        </div>
    </div>

    <div class="card-body p-4">
        <form method="post" class="row">
            <div class="border p-3">
                <div class="row pb-2">
                    <!-- <hr/> -->
                </div>
                <!-- <div asp-validation-summary="All"></div> -->
                <!-- <div asp-validation-summary="ModelOnly"></div> -->
                <div class="form-floating py-2 col-12">
                    <input asp-for="Name" class="form-control border-0 shadow"></input>
                    <label asp-for="Name" class="ms-2"></label>
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="form-floating py-2 col-12">
                    <input asp-for="DisplayOrder" class="form-control border-0 shadow"></input>
                    <label asp-for="DisplayOrder" class="ms-2"></label>
                    <span asp-validation-for="DisplayOrder" class="text-danger"></span>
                </div>
                <div class="row pt-2">
                    <div class="col-md-6 col-md-3">
                        <button type="submit" class="btn btn-primary" style="width:120px">Create</button>
                        <a asp-controller="Category" asp-action="Index" class="btn btn-secondary" >Back to Categories</a>
                    </div>
                    <!-- <div class="col-3 col-md-3">
                         <a asp-controller="Category" asp-action="Index" class="btn btn-secondary" >Back to Categories</a>
                         </div> -->
                </div>
            </div>
        </form>
    </div>
</div>




@section scripts {
    @{
        <partial name="_ValidationScriptsPartial" />
    }
}

BulkyWeb/Areas/Admin/Views/Category/Index.cshtml
@{
    ViewData["Title"] = "Category List";
}

<div class="card shadow border-0 mt-4">
    <div class="card-header bg-secondary bg-gradient ml-0 py-3">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">Category List</h2>
            </div>
        </div>
    </div>

    <div class="card-body p-4">
        <div class="row pb-3">
            <div class="col-12 text-end">
                <a asp-controller="Category" asp-action="Create" class="btn btn-primary">
                    Create new Category<span>&nbsp;&nbsp;</span><i class="bi bi-plus-square-dotted"></i>
                </a>
            </div>
        </div>
    <table class="table table-bordered table-striped p-2">
        <thead>
            <tr>
                <th>
                    <h5><b>Category Name</b></h5>
                </th>
                <th>
                    <h5><b>Display Orders</b></h5>
                </th>
                <th>
                    <h5><b>Actions</b></h5>
                </th>
            </tr>
        </thead>
        <tbody>
            @foreach (var obj in Model)
            {
                    <tr>
                        <td>
                            <h6>@obj.Name</h6>
                        </td>
                        <td>
                            <h6>@obj.DisplayOrder</h6>
                        </td>
                        <td>
                            <div class="w-75 btn-group" role="group">
                                <a asp-controller="Category" asp-action="Edit" asp-route-id="@obj.Id" class="btn btn-primary mx-2">
                                    <i class="bi bi-pencil-square"></i> Edit
                                </a>
                                <a asp-controller="Category" asp-action="Delete" asp-route-id="@obj.Id" class="btn btn-danger mx-2">
                                    <i class="bi bi-trash3"></i> Delete
                                </a>
                            </div>
                        </td>
                    </tr>
            }
        </tbody>
    </table>
</div>